// This file was generated by gir (https://github.com/gtk-rs/gir)
// from
// from gir-files (https://github.com/gtk-rs/gir-files.git)
// DO NOT EDIT

use glib::{
    prelude::*,
    signal::{connect_raw, SignalHandlerId},
    translate::*,
};
use std::{boxed::Box as Box_, fmt, mem::transmute};

#[cfg(feature = "gtk_v3_4")]
#[cfg_attr(docsrs, doc(cfg(feature = "gtk_v3_4")))]
glib::wrapper! {
    #[doc(alias = "DzlProgressMenuButton")]
    pub struct ProgressMenuButton(Object<ffi::DzlProgressMenuButton, ffi::DzlProgressMenuButtonClass>) @extends gtk::MenuButton, gtk::Button, gtk::Bin, gtk::Container, gtk::Widget, @implements gtk::Buildable, gtk::Actionable;

    match fn {
        type_ => || ffi::dzl_progress_menu_button_get_type(),
    }
}

#[cfg(not(any(feature = "gtk_v3_4")))]
glib::wrapper! {
    #[doc(alias = "DzlProgressMenuButton")]
    pub struct ProgressMenuButton(Object<ffi::DzlProgressMenuButton, ffi::DzlProgressMenuButtonClass>) @extends gtk::MenuButton, gtk::Button, gtk::Bin, gtk::Container, gtk::Widget, @implements gtk::Buildable;

    match fn {
        type_ => || ffi::dzl_progress_menu_button_get_type(),
    }
}

impl ProgressMenuButton {
    pub const NONE: Option<&'static ProgressMenuButton> = None;

    #[doc(alias = "dzl_progress_menu_button_new")]
    pub fn new() -> ProgressMenuButton {
        assert_initialized_main_thread!();
        unsafe { gtk::Widget::from_glib_none(ffi::dzl_progress_menu_button_new()).unsafe_cast() }
    }
}

impl Default for ProgressMenuButton {
    fn default() -> Self {
        Self::new()
    }
}

mod sealed {
    pub trait Sealed {}
    impl<T: super::IsA<super::ProgressMenuButton>> Sealed for T {}
}

pub trait ProgressMenuButtonExt: IsA<ProgressMenuButton> + sealed::Sealed + 'static {
    #[doc(alias = "dzl_progress_menu_button_get_progress")]
    #[doc(alias = "get_progress")]
    fn progress(&self) -> f64 {
        unsafe { ffi::dzl_progress_menu_button_get_progress(self.as_ref().to_glib_none().0) }
    }

    #[doc(alias = "dzl_progress_menu_button_get_show_progress")]
    #[doc(alias = "get_show_progress")]
    fn shows_progress(&self) -> bool {
        unsafe {
            from_glib(ffi::dzl_progress_menu_button_get_show_progress(
                self.as_ref().to_glib_none().0,
            ))
        }
    }

    #[doc(alias = "dzl_progress_menu_button_get_show_theatric")]
    #[doc(alias = "get_show_theatric")]
    fn shows_theatric(&self) -> bool {
        unsafe {
            from_glib(ffi::dzl_progress_menu_button_get_show_theatric(
                self.as_ref().to_glib_none().0,
            ))
        }
    }

    #[doc(alias = "dzl_progress_menu_button_reset_theatrics")]
    fn reset_theatrics(&self) {
        unsafe {
            ffi::dzl_progress_menu_button_reset_theatrics(self.as_ref().to_glib_none().0);
        }
    }

    #[doc(alias = "dzl_progress_menu_button_set_progress")]
    fn set_progress(&self, progress: f64) {
        unsafe {
            ffi::dzl_progress_menu_button_set_progress(self.as_ref().to_glib_none().0, progress);
        }
    }

    #[doc(alias = "dzl_progress_menu_button_set_show_progress")]
    fn set_show_progress(&self, show_progress: bool) {
        unsafe {
            ffi::dzl_progress_menu_button_set_show_progress(
                self.as_ref().to_glib_none().0,
                show_progress.into_glib(),
            );
        }
    }

    #[doc(alias = "dzl_progress_menu_button_set_show_theatric")]
    fn set_show_theatric(&self, show_theatic: bool) {
        unsafe {
            ffi::dzl_progress_menu_button_set_show_theatric(
                self.as_ref().to_glib_none().0,
                show_theatic.into_glib(),
            );
        }
    }

    #[doc(alias = "theatric-icon-name")]
    fn theatric_icon_name(&self) -> Option<glib::GString> {
        ObjectExt::property(self.as_ref(), "theatric-icon-name")
    }

    #[doc(alias = "theatric-icon-name")]
    fn set_theatric_icon_name(&self, theatric_icon_name: Option<&str>) {
        ObjectExt::set_property(self.as_ref(), "theatric-icon-name", theatric_icon_name)
    }

    #[doc(alias = "transition-duration")]
    fn transition_duration(&self) -> u32 {
        ObjectExt::property(self.as_ref(), "transition-duration")
    }

    #[doc(alias = "transition-duration")]
    fn set_transition_duration(&self, transition_duration: u32) {
        ObjectExt::set_property(self.as_ref(), "transition-duration", transition_duration)
    }

    #[doc(alias = "progress")]
    fn connect_progress_notify<F: Fn(&Self) + 'static>(&self, f: F) -> SignalHandlerId {
        unsafe extern "C" fn notify_progress_trampoline<
            P: IsA<ProgressMenuButton>,
            F: Fn(&P) + 'static,
        >(
            this: *mut ffi::DzlProgressMenuButton,
            _param_spec: glib::ffi::gpointer,
            f: glib::ffi::gpointer,
        ) {
            let f: &F = &*(f as *const F);
            f(ProgressMenuButton::from_glib_borrow(this).unsafe_cast_ref())
        }
        unsafe {
            let f: Box_<F> = Box_::new(f);
            connect_raw(
                self.as_ptr() as *mut _,
                b"notify::progress\0".as_ptr() as *const _,
                Some(transmute::<_, unsafe extern "C" fn()>(
                    notify_progress_trampoline::<Self, F> as *const (),
                )),
                Box_::into_raw(f),
            )
        }
    }

    #[doc(alias = "show-progress")]
    fn connect_show_progress_notify<F: Fn(&Self) + 'static>(&self, f: F) -> SignalHandlerId {
        unsafe extern "C" fn notify_show_progress_trampoline<
            P: IsA<ProgressMenuButton>,
            F: Fn(&P) + 'static,
        >(
            this: *mut ffi::DzlProgressMenuButton,
            _param_spec: glib::ffi::gpointer,
            f: glib::ffi::gpointer,
        ) {
            let f: &F = &*(f as *const F);
            f(ProgressMenuButton::from_glib_borrow(this).unsafe_cast_ref())
        }
        unsafe {
            let f: Box_<F> = Box_::new(f);
            connect_raw(
                self.as_ptr() as *mut _,
                b"notify::show-progress\0".as_ptr() as *const _,
                Some(transmute::<_, unsafe extern "C" fn()>(
                    notify_show_progress_trampoline::<Self, F> as *const (),
                )),
                Box_::into_raw(f),
            )
        }
    }

    #[doc(alias = "show-theatric")]
    fn connect_show_theatric_notify<F: Fn(&Self) + 'static>(&self, f: F) -> SignalHandlerId {
        unsafe extern "C" fn notify_show_theatric_trampoline<
            P: IsA<ProgressMenuButton>,
            F: Fn(&P) + 'static,
        >(
            this: *mut ffi::DzlProgressMenuButton,
            _param_spec: glib::ffi::gpointer,
            f: glib::ffi::gpointer,
        ) {
            let f: &F = &*(f as *const F);
            f(ProgressMenuButton::from_glib_borrow(this).unsafe_cast_ref())
        }
        unsafe {
            let f: Box_<F> = Box_::new(f);
            connect_raw(
                self.as_ptr() as *mut _,
                b"notify::show-theatric\0".as_ptr() as *const _,
                Some(transmute::<_, unsafe extern "C" fn()>(
                    notify_show_theatric_trampoline::<Self, F> as *const (),
                )),
                Box_::into_raw(f),
            )
        }
    }

    #[doc(alias = "theatric-icon-name")]
    fn connect_theatric_icon_name_notify<F: Fn(&Self) + 'static>(&self, f: F) -> SignalHandlerId {
        unsafe extern "C" fn notify_theatric_icon_name_trampoline<
            P: IsA<ProgressMenuButton>,
            F: Fn(&P) + 'static,
        >(
            this: *mut ffi::DzlProgressMenuButton,
            _param_spec: glib::ffi::gpointer,
            f: glib::ffi::gpointer,
        ) {
            let f: &F = &*(f as *const F);
            f(ProgressMenuButton::from_glib_borrow(this).unsafe_cast_ref())
        }
        unsafe {
            let f: Box_<F> = Box_::new(f);
            connect_raw(
                self.as_ptr() as *mut _,
                b"notify::theatric-icon-name\0".as_ptr() as *const _,
                Some(transmute::<_, unsafe extern "C" fn()>(
                    notify_theatric_icon_name_trampoline::<Self, F> as *const (),
                )),
                Box_::into_raw(f),
            )
        }
    }

    #[doc(alias = "transition-duration")]
    fn connect_transition_duration_notify<F: Fn(&Self) + 'static>(&self, f: F) -> SignalHandlerId {
        unsafe extern "C" fn notify_transition_duration_trampoline<
            P: IsA<ProgressMenuButton>,
            F: Fn(&P) + 'static,
        >(
            this: *mut ffi::DzlProgressMenuButton,
            _param_spec: glib::ffi::gpointer,
            f: glib::ffi::gpointer,
        ) {
            let f: &F = &*(f as *const F);
            f(ProgressMenuButton::from_glib_borrow(this).unsafe_cast_ref())
        }
        unsafe {
            let f: Box_<F> = Box_::new(f);
            connect_raw(
                self.as_ptr() as *mut _,
                b"notify::transition-duration\0".as_ptr() as *const _,
                Some(transmute::<_, unsafe extern "C" fn()>(
                    notify_transition_duration_trampoline::<Self, F> as *const (),
                )),
                Box_::into_raw(f),
            )
        }
    }
}

impl<O: IsA<ProgressMenuButton>> ProgressMenuButtonExt for O {}

impl fmt::Display for ProgressMenuButton {
    fn fmt(&self, f: &mut fmt::Formatter) -> fmt::Result {
        f.write_str("ProgressMenuButton")
    }
}
